﻿IncludeFile "Editeur D'expression 1.20.pb"

Enumeration MaFenetre
  #MaFenetre
EndEnumeration

Enumeration MesGadgets
  
  #TexteInfo_String_Valeur_Quelconque
  #String_Valeur_Quelconque
  #Bouton_Ouvrir_Editeur_Expression_Valeur_Quelconque
  
  #TexteInfo_String_Valeur_Chaine_Caracteres
  #String_Valeur_Chaine_Caracteres
  #Bouton_Ouvrir_Editeur_Expression_Chaine_Caracteres
  
  #TexteInfo_String_Valeur_Nombre
  #String_Valeur_Nombre
  #Bouton_Ouvrir_Editeur_Expression_Nombre
  
EndEnumeration

If OpenWindow(#MaFenetre, 327, 177, 500, 150, "Fenêtre Exemple...",  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered | #PB_Window_TitleBar)
  
  TextGadget(#TexteInfo_String_Valeur_Quelconque, 12, 12, 295, 15, "Veuillez entrez une valeur quelconque:", #PB_Text_Center)
  StringGadget(#String_Valeur_Quelconque, 12, 29, 295, 19, "123.369", #PB_String_ReadOnly | #WS_EX_STATICEDGE | #WS_BORDER)
  ButtonGadget(#Bouton_Ouvrir_Editeur_Expression_Valeur_Quelconque, 313, 26, 175, 25, "Ouvrir L'Editeur d'Expression")
  
  TextGadget(#TexteInfo_String_Valeur_Chaine_Caracteres, 12, 55, 295, 15, "Veuillez entrez une chaîne de caractère:", #PB_Text_Center)
  StringGadget(#String_Valeur_Chaine_Caracteres, 12, 72, 295, 19, "Ceci est une " + Chr(34) + "chaîne de caractères" + Chr(34), #PB_String_ReadOnly | #WS_EX_STATICEDGE | #WS_BORDER)
  ButtonGadget(#Bouton_Ouvrir_Editeur_Expression_Chaine_Caracteres, 313, 69, 175, 25, "Ouvrir L'Editeur d'Expression")
  
  TextGadget(#TexteInfo_String_Valeur_Nombre, 12, 98, 295, 15, "Veuillez entrez un nombre:", #PB_Text_Center)
  StringGadget(#String_Valeur_Nombre, 12, 115, 295, 19, "123456789.123456789", #PB_String_ReadOnly | #WS_EX_STATICEDGE | #WS_BORDER)
  ButtonGadget(#Bouton_Ouvrir_Editeur_Expression_Nombre, 313, 112, 175, 25, "Ouvrir L'Editeur d'Expression")
  
EndIf

;{- Evenements du programme

Repeat ; Départ des évènements de boucle
  
  Event = WaitWindowEvent(1) ; Cette ligne attend qu'un évènement soit reçu par la fenêtre
  EventWindow = EventWindow(); La fenêtre ou l'évènement s'est produit
  EventGadget = EventGadget(); Pour savoir sur quel gadget s'est produit l'évènement
  
  Select EventWindow
      
    Case #MaFenetre ; Autre fenêtre
      
      Select Event
          
        Case #PB_Event_Gadget
          
          Select EventGadget
              
            Case #Bouton_Ouvrir_Editeur_Expression_Valeur_Quelconque
              
              ; Ouverture de l'editeur d'expression
              Resultat$ = OuvrirFenetreEditeurExpression(GetGadgetText(#String_Valeur_Quelconque), #MaFenetre, 1, 1, -1)
              
              If Resultat$ <> ""
                
                Debug "La chaîne de retour est: " + Resultat$
                Debug ""
                Debug "Le mode de sortie est: " + StringField(Resultat$, 2, "|")
                
                Select Val(StringField(Resultat$, 1, "|"))
                    
                  Case 3
                    Debug "Pas de type de sortie."
                    Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 3, #True)
                    SetGadgetText(#String_Valeur_Quelconque, ExtraireResultatEditeur(Resultat$, 3, #True))
                    
                  Case 4
                    
                    If StringField(Resultat$, 2, "|") <> "StrF" And StringField(Resultat$, 2, "|") <> "StrD"
                      
                      Debug "Le Type de sortie est: " + StringField(Resultat$, 3, "|")
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #True)
                      SetGadgetText(#String_Valeur_Quelconque, ExtraireResultatEditeur(Resultat$, 4, #True))
                      
                    Else
                      
                      Debug "Pas de type de sortie."
                      Debug "Le Nombre de décimale est: " + StringField(Resultat$, 3, "|")
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #True)
                      SetGadgetText(#String_Valeur_Quelconque, ExtraireResultatEditeur(Resultat$, 4, #True))
                      
                    EndIf
                    
                  Case 5
                    
                    Debug "Le Type de sortie est: " + StringField(Resultat$, 3, "|")
                    Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #False)
                    Debug "Le script de sortie est: " + ExtraireResultatEditeur(Resultat$, 5, #True)
                    SetGadgetText(#String_Valeur_Quelconque, ExtraireResultatEditeur(Resultat$, 5, #True))
                    
                EndSelect
                
              Else
                Debug "L'utilisateur a annulé."
                
              EndIf
              
            Case #Bouton_Ouvrir_Editeur_Expression_Chaine_Caracteres
              
              ; Ouverture de l'editeur d'expression
              Resultat$ = OuvrirFenetreEditeurExpression(GetGadgetText(#String_Valeur_Chaine_Caracteres), #MaFenetre, 1, 1, -1)
              
              If Resultat$ <> ""
                
                Debug "La chaîne de retour est: " + Resultat$
                Debug ""
                Debug "Le mode de sortie est: " + StringField(Resultat$, 2, "|")
                
                If StringField(Resultat$, 2, "|") <> "Bin" And StringField(Resultat$, 2, "|") <> "Hex" And StringField(Resultat$, 2, "|") <> "String" And StringField(Resultat$, 2, "|") <> "Script"
                  MessageRequester("Mauvais Mode de sortie !", "   Vous n'avez pas entré le bon mode de sortie !" + Chr(13) + "    Les modes de sortie valide sont:" + Chr(13) + Chr(13) + "    Bin, Hex, String et Script de type String !", 16)
                  
                Else
                  
                  Select Val(StringField(Resultat$, 1, "|"))
                      
                    Case 3 ; String
                      
                      Debug "Pas de type de sortie."
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 3, #True)
                      SetGadgetText(#String_Valeur_Chaine_Caracteres, ExtraireResultatEditeur(Resultat$, 3, #True))
                      
                    Case 4 ; Bin et Hex
                      
                      Debug "Le Type de sortie est: " + StringField(Resultat$, 3, "|")
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #True)
                      SetGadgetText(#String_Valeur_Chaine_Caracteres, ExtraireResultatEditeur(Resultat$, 4, #True))
                      
                    Case 5 ; Script
                      
                      Debug "Le Type de sortie est: " + StringField(Resultat$, 3, "|")
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #False)
                      Debug "Le script de sortie est: " + ExtraireResultatEditeur(Resultat$, 5, #True)
                      
                      Select StringField(Resultat$, 3, "|")
                          
                        Case "String"
                          SetGadgetText(#String_Valeur_Chaine_Caracteres, ExtraireResultatEditeur(Resultat$, 5, #True))
                          
                        Case "Numérique"
                          MessageRequester("Mauvais type de valeur !", "   Vous n'avez pas entrez le bon type de valeur !" + Chr(13) + "    Le types de valeur valide est Chaîne de caractères !", 16)
                          
                      EndSelect
                      
                  EndSelect
                  
                EndIf
                
              Else
                Debug "L'utilisateur a annulé."
                
              EndIf
              
            Case #Bouton_Ouvrir_Editeur_Expression_Nombre
              
              ; Ouverture de l'editeur d'expression
              Resultat$ = OuvrirFenetreEditeurExpression(GetGadgetText(#String_Valeur_Nombre), #MaFenetre, 1, 1, -1)
              
              If Resultat$ <> ""
                
                Debug "La chaîne de retour est: " + Resultat$
                Debug ""
                Debug "Le mode de sortie est: " + StringField(Resultat$, 2, "|")
                
                If StringField(Resultat$, 2, "|") <> "Str" And StringField(Resultat$, 2, "|") <> "StrU" And StringField(Resultat$, 2, "|") <> "StrF" And StringField(Resultat$, 2, "|") <> "StrD" And StringField(Resultat$, 2, "|") <> "Script"
                  MessageRequester("Mauvais Mode de sortie !", "   Vous n'avez pas entré le bon mode de sortie !" + Chr(13) + "    Les modes de sortie valide sont:" + Chr(13) + Chr(13) + "    Str, StrU, StrF, StrD et Script de type Nombre !", 16)
                  
                Else
                  
                  Select Val(StringField(Resultat$, 1, "|"))
                      
                    Case 3 ; Str
                      
                      Debug "Pas de type de sortie."
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 3, #True)
                      SetGadgetText(#String_Valeur_Nombre, ExtraireResultatEditeur(Resultat$, 3, #True))
                      
                    Case 4 ; StrU, StrF, StrD
                      
                      Debug "Le Type de sortie est: " + StringField(Resultat$, 3, "|")
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #True)
                      SetGadgetText(#String_Valeur_Nombre, ExtraireResultatEditeur(Resultat$, 4, #True))
                      
                    Case 5 ; Script
                      
                      Debug "Le Type de sortie est: " + StringField(Resultat$, 3, "|")
                      Debug "Le résultat de sortie est: " + ExtraireResultatEditeur(Resultat$, 4, #False)
                      Debug "Le script de sortie est: " + ExtraireResultatEditeur(Resultat$, 5, #True)
                      
                      Select StringField(Resultat$, 3, "|")
                          
                        Case "String"
                          MessageRequester("Mauvais type de valeur !", "   Vous n'avez pas entrez le bon type de valeur !" + Chr(13) + "    Le types de valeur valide est Nombre !", 16)

                        Case "Numérique"
                          SetGadgetText(#String_Valeur_Nombre, ExtraireResultatEditeur(Resultat$, 5, #True))
                          
                      EndSelect
                      
                  EndSelect
                  
                EndIf
                
              Else
                Debug "L'utilisateur a annulé."
                
              EndIf
              
          EndSelect
          
        Case #PB_Event_CloseWindow  
          End
          
      EndSelect
      
  EndSelect
  
ForEver

;}
; IDE Options = PureBasic 5.44 LTS (Windows - x64)
; CursorPosition = 1
; Folding = -
; EnableXP
; EnableUser
; EnableOnError
; EnableCompileCount = 166
; EnableBuildCount = 0
; EnableExeConstant